
#define FALSE 0

#define TRUE 1
double u [97], c, cd, cm;
int i97, j97;
int test = FALSE;

void RandomInitialise (int ij, int kl) {
    double s, t;
    int ii, i, j, k, l, jj, m;
    if (ij < 0 || ij > 31328 || kl < 0 || kl > 30081) {
        ij = 1802;
        kl = 9373;
    }
    i = (ij / 177) % 177 + 2;
    j = (ij % 177) + 2;
    k = (kl / 169) % 178 + 1;
    l = (kl % 169);
    for (ii = 0; ii < 97; ii++) {
        s = 0.0;
        t = 0.5;
        for (jj = 0; jj < 24; jj++) {
            m = (((i * j) % 179) * k) % 179;
            i = j;
            j = k;
            k = m;
            l = (53 * l + 1) % 169;
            if (((l * m % 64)) >= 32)
                s += t;
            t *= 0.5;
        }
        u[ii] = s;
    }
    c = 362436.0 / 16777216.0;
    cd = 7654321.0 / 16777216.0;
    cm = 16777213.0 / 16777216.0;
    i97 = 97;
    j97 = 33;
    test = TRUE;
}

double RandomUniform (void) {
    double uni;
    if (!test)
        RandomInitialise (1802, 9373);
    uni = u[i97 - 1] - u[j97 - 1];
    if (uni <= 0.0)
        uni++;
    u[i97 - 1] = uni;
    i97--;
    if (i97 == 0)
        i97 = 97;
    j97--;
    if (j97 == 0)
        j97 = 97;
    c -= cd;
    if (c < 0.0)
        c += cm;
    uni -= c;
    if (uni < 0.0)
        uni++;
    return (uni);
}

double RandomGaussian (double mean, double stddev) {
    double q, u, v, x, y;
    do {
        u = RandomUniform ();
        v = RandomUniform ();
        if (u <= 0.0 || v <= 0.0) {
            u = 1.0;
            v = 1.0;
        }
        v = 1.7156 * (v - 0.5);
        x = u - 0.449871;
        y = fabs (v) + 0.386595;
        q = x * x + y * (0.19600 * y - 0.25472 * x);
        if (q < 0.27597)
            break;
    }
    while ((q > 0.27846) || (v * v > -4.0 * log (u) * u * u));
    return (mean + stddev * v / u);
}

int RandomInt (int lower, int upper) {
    return ((int) (RandomUniform () * (upper - lower + 1)) + lower);
}

double RandomDouble (double lower, double upper) {
    return ((upper - lower) * RandomUniform () + lower);
}

